#ifndef MALACHSCRIPT_FUNCATTR_HPP
#define MALACHSCRIPT_FUNCATTR_HPP

#include <cstdint>
namespace MalachScript {
    enum class FuncAttr : uint8_t {
        None = 0,
        Override = 1 << 1,
        Final = 1 << 2,
        Explicit = 1 << 3,
        Property = 1 << 4,
    };

    class FuncAttrHelpers {
    public:
        constexpr inline static bool Contains(FuncAttr set, FuncAttr flag) {
            return (static_cast<uint8_t>(set) & static_cast<uint8_t>(flag)) != 0;
        }
        constexpr inline static FuncAttr Set(FuncAttr set, FuncAttr flag) {
            return static_cast<FuncAttr>(static_cast<uint8_t>(set) | static_cast<uint8_t>(flag));
        }
    };
}

#endif // MALACHSCRIPT_FUNCATTR_HPP
