#ifndef MALACHSCRIPT_PRIMITIVETYPES_HPP
#define MALACHSCRIPT_PRIMITIVETYPES_HPP

#include <string>
#include "Identifier.hpp"

#if !__cpp_constinit
#define constinit constexpr
#endif

namespace MalachScript {
    static constinit Identifier _voidName = u8"void";
    static constinit Identifier _intName = u8"int";
    static constinit Identifier _int8Name = u8"int8";
    static constinit Identifier _int16Name = u8"int16";
    static constinit Identifier _int32Name = u8"int32";
    static constinit Identifier _int64Name = u8"int64";
    static constinit Identifier _uintName = u8"uint";
    static constinit Identifier _uint8Name = u8"uint8";
    static constinit Identifier _uint16Name = u8"uint16";
    static constinit Identifier _uint32Name = u8"uint32";
    static constinit Identifier _uint64Name = u8"uint64";
    static constinit Identifier _floatName = u8"float";
    static constinit Identifier _doubleName = u8"double";
    static constinit Identifier _boolName = u8"bool";

    static constinit Identifier _autoName = u8"auto";

    class PrimitiveTypes {
    public:
        constexpr static const Identifier& VoidName() noexcept { return _voidName; }
        constexpr static const Identifier& IntName() noexcept { return _intName; }
        constexpr static const Identifier& Int8Name() noexcept { return _int8Name; }
        constexpr static const Identifier& Int16Name() noexcept { return _int16Name; }
        constexpr static const Identifier& Int32Name() noexcept { return _int32Name; }
        constexpr static const Identifier& Int64Name() noexcept { return _int64Name; }
        constexpr static const Identifier& UintName() noexcept { return _uintName; }
        constexpr static const Identifier& Uint8Name() noexcept { return _uint8Name; }
        constexpr static const Identifier& Uint16Name() noexcept { return _uint16Name; }
        constexpr static const Identifier& Uint32Name() noexcept { return _uint32Name; }
        constexpr static const Identifier& Uint64Name() noexcept { return _uint64Name; }
        constexpr static const Identifier& FloatName() noexcept { return _floatName; }
        constexpr static const Identifier& DoubleName() noexcept { return _doubleName; }
        constexpr static const Identifier& BoolName() noexcept { return _boolName; }
        constexpr static const Identifier& AutoName() noexcept { return _autoName; }
    };
}

#endif // MALACHSCRIPT_PRIMITIVETYPES_HPP
