#ifndef MALACHSCRIPT_LEXRESULT_HPP
#define MALACHSCRIPT_LEXRESULT_HPP

#include "LexToken.hpp"
namespace MalachScript::Parser {
    class LexResult {
    public:
        LexResult(const LexToken* first, const uint8_t* memoryMap) : _first(first), _memoryMap(memoryMap) {}

        [[nodiscard]] const LexToken* GetFirst() const noexcept { return _first; }
        [[nodiscard]] const uint8_t* GetMemoryMap() const noexcept { return _memoryMap; }

    private:
        const LexToken* _first;
        const uint8_t* _memoryMap;
    };
}

#endif // MALACHSCRIPT_LEXRESULT_HPP
